package net.t2code.t2codelib.BUNGEE.system.config;

import net.md_5.bungee.config.Configuration;
import net.md_5.bungee.config.ConfigurationProvider;
import net.md_5.bungee.config.YamlConfiguration;
import net.t2code.t2codelib.BUNGEE.api.messages.T2CBsend;
import net.t2code.t2codelib.BUNGEE.api.yaml.T2CBconfig;
import net.t2code.t2codelib.BUNGEE.system.T2CodeBMain;
import net.t2code.t2codelib.Util;

import java.io.File;
import java.io.IOException;

public class T2CBlibConfig {

    public static void create() throws IOException {
        long long_ = System.currentTimeMillis();
        File config = new File(T2CodeBMain.getPlugin().getDataFolder(), "config.yml");
        if (!T2CodeBMain.getPlugin().getDataFolder().exists()) T2CodeBMain.getPlugin().getDataFolder().mkdir();
        if (!config.exists()) {
            config.createNewFile();
        }
        Configuration configuration = ConfigurationProvider.getProvider(YamlConfiguration.class).load(config);
        T2CBconfig.set("UpdateCheck.TimerInMin", 60, configuration);

        T2CBconfig.set("API.CommandGUI.Enable", false, configuration);
        T2CBconfig.set("API.AutoResponse.Enable", false, configuration);
        T2CBconfig.set("API.OPSecurity.Enable", false, configuration);

        ConfigurationProvider.getProvider(YamlConfiguration.class).save(configuration, config);
        T2CBsend.console(Util.getPrefix() + " §2config.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }

    public static void select() throws IOException {
        File config = new File(T2CodeBMain.getPlugin().getDataFolder(), "config.yml");
        Configuration configuration = ConfigurationProvider.getProvider(YamlConfiguration.class).load(config);

        updateTimer = configuration.getInt("UpdateCheck.TimerInMin");
        seePreReleaseUpdates = configuration.getBoolean("UpdateCheck.SeePreReleaseUpdates");

        apiCommandGUIEnable = configuration.getBoolean("API.CommandGUI.Enable");
        apiAutoResponse = configuration.getBoolean("API.AutoResponse.Enable");
        apiOpSecurity = configuration.getBoolean("API.OPSecurity.Enable");
    }

    private static Integer updateTimer;
    private static Boolean seePreReleaseUpdates;
    private static Boolean apiCommandGUIEnable;
    private static Boolean apiAutoResponse;
    private static Boolean apiOpSecurity;

    public static Integer getUpdateTimer() {
        return updateTimer;
    }

    public static Boolean getSeePreReleaseUpdates() {
        return seePreReleaseUpdates;
    }

    public static Boolean getApiCommandGUIEnable() {
        return apiCommandGUIEnable;
    }

    public static Boolean getApiAutoResponse() {
        return apiAutoResponse;
    }

    public static Boolean getApiOpSecurity() {
        return apiOpSecurity;
    }
}
