package net.t2code.t2codelib.SPIGOT.system.config.languages;

import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2Cconfig;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import net.t2code.t2codelib.Util;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.plugin.Plugin;

import java.io.File;
import java.io.IOException;

public class LanguagesCreate {
    static Plugin plugin = T2CodeLibMain.getPlugin();

    public static void langCreate() {
        T2Csend.debug(plugin, "§4Language files are created / updated...");
        long long_ = System.currentTimeMillis();


        setFile("english", MSG.EN_VaultNotSetUp, MSG.EN_VotingPluginNotSetUp, MSG.EN_SoundNotFound);

        setFile("german", MSG.DE_VaultNotSetUp, MSG.DE_VotingPluginNotSetUp, MSG.DE_SoundNotFound);

        setFile("norwegian", MSG.NO_VaultNotSetUp, MSG.NO_VotingPluginNotSetUp, MSG.NO_SoundNotFound);

        T2Csend.console(Util.getPrefix() + " §2Language files were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }

    private static void setFile(String language, String vaultNotSetUp, String votingPluginNotSetUp, String soundNotFound) {
        File messages = new File(T2CodeLibMain.getPath(), "languages/" + language + ".yml");
        YamlConfiguration yamlConfigurationNO = YamlConfiguration.loadConfiguration(messages);

        T2Cconfig.set("Plugin.VaultNotSetUp", vaultNotSetUp, yamlConfigurationNO);
        T2Cconfig.set("Plugin.VotingPluginNotSetUp", votingPluginNotSetUp, yamlConfigurationNO);
        T2Cconfig.set("Plugin.SoundNotFound", soundNotFound, yamlConfigurationNO);

        try {
            yamlConfigurationNO.save(messages);
        } catch (IOException e) {
            T2Csend.warning(plugin, e.getMessage());
            e.printStackTrace();
        }
    }
}
